#pragma once
#include <map>

#include "ManagerInterface.h"
#include "BuddyUser.h"
#include "BuddyGroup.h"
//#include "RoomManager.h"

#include "WASActor.h"
#include "ProfileImageActor.h"
#include "Mutex.h"

/////////////////////////////////////////////
#include "incconferenceintf.h"
/////////////////////////////////////////////

#include "ActorInterface_Private.h"
#include "MainActor.h"
#include "NpMsgr.h"

#define MSG_ROOM_INVITE_RESULT		0x01000000

class CWASActor;
class CProfileImageActor;

class CMessengerActor : public CMainActor
	, public IGTMessengerActor
	, public _INpMsgrEvents
	, public _INpMsgrBuddyEvents
	, public _INpMsgrIPTEvents
	, public _INpSessionDispatcher_PacketHandler
	, public IGTWASActorEventPrivate
{
public:
	CMessengerActor(void);
	virtual ~CMessengerActor(void);

	// For GTObject
protected:	
	virtual void OnReleaseObject(void) { delete this; }
	

	// Public Method..
public:
	virtual void GetMyUserInfo(GT_MY_USER_DATA &data);
	virtual void GetMyUserProfile(GT_USER_PROFILE_DATA &sData);
    virtual void GetMyMobileUserProfile(GT_MOBILE_USER_PROFILE_DATA &sData);
	virtual void GetUserLevels(NE_LEVEL_DATA_LIST &sLevels);
    
	virtual void GetLoginErrorData(GT_LOGIN_ERROR_DATA &data)
	{
		m_sLoginErrorData.Convert(data);
	}

	//virtual void RegisterObserver(IGTMessengerActorEvent *pOb);
	//virtual void UnRegisterObserver(IGTMessengerActorEvent *pOb);

	virtual LPCWSTR GetUserID(void)
	{
		return m_sMyUserData.strUserID.c_str();
	}
	virtual LPCWSTR GetUserPassword(void)
	{
		return m_sMyUserData.strUserPWD.c_str();
	}
	virtual LPCWSTR GetTalkName(void)
	{
		return m_sMyUserData.sMyPage.strTalkName.c_str();
	}
	virtual LPCSTR GetMobilePhoneNumber(void)
	{
		return m_strMyPhoneNumber.c_str();
	}
	virtual LPCWSTR GetFunction(void)
	{
		return m_sMyUserData.sMyPage.strFunction.c_str();
	}
	
	virtual GTMessengerActorState GetActorState(void)
	{
		return m_sMyUserData.eLoginState;
	}

	virtual GTUserStatusType GetMyStatus(void)
	{
		return m_sMyUserData.eUserStatusType;
	}

	virtual NTIPTStatusType GetMyIptStatus(void)
	{
		return m_sMyUserData.eIptStatusType;
	}

	virtual GTLogoutReasonType GetLogoutReasonType(void)
	{
		return m_eLogoutType;
	}

	virtual LPCSTR GetMessengerTicketType(void)
	{
		return m_strTicketType.c_str();
	}

	virtual LPCSTR GetMessengerTicket(void)
	{
		GT_ASSERT(m_pNpMsgr); 
		return m_pNpMsgr->GetNpMsgrUser()->AuthCookie();
	}

	virtual LPCSTR GetNewMessengerTicket(void);

	virtual bool IsValidLoginState(void);

	virtual bool IsEverLoginSuccess(void)
	{
		return m_bIsEverLoginOKFlag;
	}
	virtual bool IsFirstLogin(void)
	{
		return m_bIsFirstLogin;
	}
	virtual bool IsAdult(void)
	{
		return m_sMyUserData.sMyPage.bAdultFlag;
	}

	virtual int GetCategoryCacheSerial(void)
	{
		return m_nCategoryCacheSerial;
	}

	virtual bool IsMobileLogin(void)
	{
		return m_bMobileLoginFlag;
	}
	
	virtual int GetActiveSerialSpecInfo(void)
	{
		if(NULL == m_pNpMsgr)
			return 0;
		return m_pNpMsgr->GetNpMsgrUser()->CacheSerial_Spec();
	}
	
	virtual int GetActiveSerialInviteBuddy(void)
	{
		if(NULL == m_pNpMsgr)
			return 0;
		return m_pNpMsgr->GetNpMsgrUser()->CacheSerial_Invite();
	}
	
	virtual int GetActiveSerialBuddy(void)
	{
		if(NULL == m_pNpMsgr)
			return 0;
		return m_pNpMsgr->GetNpMsgrUser()->CacheSerial_Buddy();
	}

    virtual int GetActiveSerialBuddyAddressBook(void)
	{
		if(NULL == m_pNpMsgr)
			return 0;
		return m_pNpMsgr->GetNpMsgrUser()->CacheSerial_BuddyAddressBook();
	}

	virtual int GetActiveSerialGroup(void)
	{
		if(NULL == m_pNpMsgr)
			return 0;
		return m_pNpMsgr->GetNpMsgrUser()->CacheSerial_Group();
	}
	
	virtual int GetActiveSerialRoomMetaData(void)
	{
		if(NULL == m_pNpMsgr)
			return 0;
		return m_pNpMsgr->GetNpMsgrUser()->CacheSerial_RoomMetaData();
	}
	
	virtual int GetActiveSerialMobileAddressBook(void)
	{
		if(NULL == m_pNpMsgr)
			return 0;
		return m_pNpMsgr->GetNpMsgrUser()->CacheSerial_MobileAddressBook();
	}
	
	virtual int GetActiveSerialRelayServer(void)
	{
		if(NULL == m_pNpMsgr)
			return 0;
		return m_pNpMsgr->GetNpMsgrUser()->CacheSerial_RelayServer();
	}
	
    virtual GTMobileAuthNumberStatusCheckResultMaskType GetMobileAuthNumberStatusCheckResultMaskType(void)
    {
 		if(NULL == m_pNpMsgr)
			return GTMobileAuthNumberStatusCheckNone;
		return m_pNpMsgr->GetNpMsgrUser()->MobileCheckResultBits();       
    }

	
	// α/ƿ  Action
	virtual bool RequestLogin(LPCWSTR tcsUserID, LPCWSTR tcsPassword, LPCWSTR tcsLangCode, LPCWSTR tcsTenantName,
							  bool bShowOfflineLogin = false, 
							  LPCWSTR tcsLoginCode = _T(""), 
							  LPCWSTR tcsTicketType = _T(""),
							  GTOSType eOSType = osWindows,
							  USHORT usCountryCode = 82, LPCSTR strMobileNumber = "", 
							  LPCSTR strMobileToken = "", 
							  GTMobileOverwriteDataType eOverwriteDataType = mobileOverwriteData_Check);
	
	virtual bool RequestLogout(GTLogoutReasonType logout_type = lortByUserCommand);
	virtual bool RequestRelogin(void);
	virtual void DisconnectLoginServer(void);

	// Health Check
	virtual void RequestRefreshTicket(void);
	virtual void RequestSendPing(void);
	virtual bool RequestPing(void);

    virtual unsigned int GetLaunchingResult(void);
    virtual LPCSTR GetLaunchingInfoURL(void);
    
	//   Action
	virtual void RequestSetMyStatus(GTUserStatusType usertype, bool bForceMode = false, const char *pCustomData = NULL, int nCustomDataSize = 0, bool bCustomDataDBSave = false);
	virtual void SetActorState(GTMessengerActorState state, bool bNotify = true, bool bDirectNotify = false);
	virtual void SetMessengerTicket(LPCSTR strTicket);
	virtual void SetMessengerTicketType(LPCSTR strType);
	
	//  Action (Import/Add/Del/Move/Block)
	virtual bool RequestImportBuddy(std::vector<IMPORT_GROUP> &vecImportBuddy, trid_t *pTrid = NULL);
	virtual bool RequestAddBuddy(int nGroupID, std::vector<wstring> &vecBuddyID, LPCWSTR strInviteMsg, NTAddBuddyType addBuddyType = abtAddBuddy, trid_t *pTrid = NULL);
	virtual bool RequestDelBuddy(std::vector<int> &vecBuddyID, trid_t *pTrid = NULL);
	virtual bool RequestMoveBuddy(std::vector<int> &vecBuddyID, int nNewGrpID, trid_t *pTrid);	
	virtual bool RequestSearchBuddy(LPCWSTR strBuddyID, trid_t *pTrid = NULL);
	virtual bool RequestRejectBuddy(LPCWSTR strBuddyID, trid_t *pTrid = NULL);
	virtual bool RequestAcceptBuddy(LPCWSTR strBuddyID, trid_t *pTrid = NULL);
	virtual bool RequestBlockBuddy(bool bBlock, LPCWSTR strBuddyID, trid_t *pTrid = NULL);
	virtual bool RequestRefreshWorkStatus(trid_t *pTrid = NULL);//  մϴ.


	// ׷ Action (Add/Del/Update)
	virtual bool RequestAddBuddyGroup(LPCWSTR strGroupName, GTBuddyAddGroupType addGroupType, int nSortOrder = 0, trid_t *pTrid = NULL);
	virtual bool RequestDelBuddyGroup(int nGroupID, trid_t *pTrid = NULL);
	virtual bool RequestUpdateBuddyGroup(int nGroupID, const GT_BUDDY_GROUP_UPDATABLE_DATA &sInfo, trid_t *pTrid = NULL);	
	virtual bool RequestUpdateBuddyGroupSortOrder(std::vector<GT_BUDDY_GROUP_DATA> &vecGroupData, trid_t *pTrid = NULL);

	//   
	virtual const IGTBuddyUser* GetBuddyInfoFromIndex(int nGroupID, size_t nIndex);
	virtual const IGTBuddyUser* GetBuddyInfoFromIndex(size_t nIndex);
	virtual const IGTBuddyUser* GetBuddyInfo(int nBuddyID);
	virtual const IGTBuddyUser* GetBuddyInfo(LPCWSTR pszBuddyID);
	virtual const IGTBuddyUser* GetBuddyInfo(LPCWSTR pszBuddyID, int nGroupID);
	virtual const IGTBuddyUser* GetBuddyInfoFromPersist(LPCWSTR pszBuddyID);

    //call GetBuddyInfo, if return NULL, then call GetBuddyInfoFromPersist
    virtual const IGTBuddyUser* GetAvailbeBuddyInfo(LPCWSTR pszBuddyID);

	virtual const NE_MEMBER_DATA* GetEmployeeInfo(LPCWSTR pszBuddyID);
	virtual size_t GetBuddyCount(void);
	virtual size_t GetBuddyCount(int nGroupID);
	virtual size_t GetBlockUserList(GT_BUDDY_DATA_LIST &list);
	virtual bool FindBuddy(LPCWSTR pszBuddyID, BYTE type = btAll);
	virtual bool IsBlockBuddy(LPCWSTR pszBuddyID);

	//  ¶ 
	virtual void RequestRegiFavoriteToPOI(vector<wstring> &vecUsers, USHORT nUserGrp);
	virtual void RequestUregFavoriteFromPOI(USHORT nUserGrp);
	virtual void RequestUregFavoriteFromPOI(vector<wstring> &vecUsers, USHORT nUserGrp);
	virtual void RequestGetBuddyStatus(std::vector<wstring> &vecUsers);

	//   ޽ 
	virtual bool RequestSendUserString(LPCWSTR pszUserID, unsigned int nUserDefinedCommand, LPCWSTR pszUserString);
	virtual bool RequestSendUserBuffer(LPCWSTR pszUserID, unsigned int nUserDefinedCommand, const char *pBuffer, int nBufferSize);


	//  ׷  
	virtual int GetDefaultGroupID(void);
	virtual size_t GetBuddyGroupCount(void);
	virtual const IGTBuddyGroup* GetBuddyGroupInfo(int nGroupID);
	virtual const IGTBuddyGroup* GetBuddyGroupInfo(LPCWSTR strGroupName);
	virtual const IGTBuddyGroup* GetBuddyGroupInfoFromIndex(size_t nIndex);


	// α  ȣϴ WAS  Action
	virtual void RequestBuddyList(bool bForceMode);
	void RequestUserImageList(LPCTSTR str);
	void RequestEmployeeInfoList();
	void RequestBuddyGroupList(void);
	void RequestMyPage(void);

	//   
	virtual size_t GetAuthDomainCount(void);
	virtual LPCWSTR GetAuthDomainFromIndex(size_t nIndex);

	// 
	virtual bool RequestSendMemo(LPCWSTR strTargetUserID, LPCWSTR strSubject, LPCWSTR strContents, trid_t *pTrid = NULL);
	virtual bool RequestSendMemoEx2(std::vector<LPCWSTR> &vecTargetUserID, LPCWSTR strContents, trid_t *pTrid = NULL);

	// Ÿ
	virtual bool GetURLPack(GT_URL_PACK_DATA &sPack);
	virtual bool GetSpecInfo(GT_API_SPEC_DATA &sSpecInfo);
	virtual bool GetFAQList(GT_FAQ_DATA_LIST &sFAQList);

	virtual IGTWASActor *GetWASActor(void) { return (IGTWASActor*)m_pWASActor; }
	virtual IGTProfileImageActor *GetProfileImageActor(void) { return m_pProfileImageActor; }
	
	virtual void SetAuthTicketProxy(IGTAuthTicketProxy *proxy)
	{
		m_pAuthTicketProxy = proxy;
	}

	// IPT
	virtual bool RequestPhoneCall(LPCWSTR strUserID, LPCWSTR strPhoneNo, trid_t *pTrid = NULL);
	virtual bool RequestAnswerCall(LPCWSTR strUserID, LPCWSTR strCID, trid_t *pTrid = NULL);
	virtual bool RequestHangUp(LPCWSTR strUserID, LPCWSTR strCID, trid_t *pTrid = NULL);
	virtual bool RequestCallForwarding(LPCWSTR strUserID, BYTE nMode, LPCWSTR strPhoneNo, trid_t *pTrid = NULL);
	virtual bool RequestCallForwardingInfo(LPCWSTR strUserID, trid_t *pTrid = NULL);
	virtual bool RequestCallTransfer(LPCWSTR strUserID, LPCWSTR strTargetID, trid_t *pTrid = NULL);
	virtual bool RequestCallPickUp(LPCWSTR strUserID, LPCWSTR strTargetID, trid_t *pTrid = NULL);
	virtual bool RequestSetDND(LPCWSTR strUserID, BYTE nMode, trid_t *pTrid = NULL);
	virtual bool RequestPhoneStatus(LPCWSTR strUserID, std::vector<LPCWSTR> &vecUserID, trid_t *pTrid = NULL);
	virtual bool RequestConferenceCall(LPCWSTR strUserID, LPCWSTR strPhoneNo, trid_t *pTrid = NULL);
	virtual bool RequestHoldCall(LPCWSTR strUserID, LPCWSTR strCID, trid_t *pTrid = NULL);
	virtual bool RequestResumeCall(LPCWSTR strUserID, LPCWSTR strCID, trid_t *pTrid = NULL);
	virtual bool RequestDndStatusInfo(LPCWSTR strUserID, trid_t *pTrid = NULL);
	

	virtual IGTBuddyGroup*	GetVirtualBuddyGroup(GT_BUDDY_GROUP_DATA data);
	virtual IGTBuddyUser*	GetVirtualBuddyUser();
	// ο ϴ public Լ
public:
	const WSTRING GetURL(LPCSTR strServer, LPCSTR strPage, LPCSTR stDefaultServer = NULL, LPCSTR strDefaultPage = NULL);
	WSTRING _DnsStateCheck(WSTRING strURL);
	void LogoutJob(GTLogoutReasonType logout_type);
	void SendMyTalkName(LPCWSTR pszTalkName);
	void SetUserProfile(const P_GT_USER_PROFILE_DATA &profile);
    void SetMobileUserProfile(const P_GT_MOBILE_USER_PROFILE_DATA &profile);
	void SetProfileImageData(const GT_PROFILE_IMAGE_DATA &image);
	GTOSType GetOSType(void)
	{
		return m_eOSType;
	}
	
	DWORD GetMainThreadID(void)
	{
		return m_pMainThreadID;
	}
	
	INpMsgr * GetNpMsgr()
	{
		return m_pNpMsgr;
	}

	//  Լ
private:
    bool _IsLoginProgress(void);
	void _ConvertMyStatus(E_MSGR_ONLINE_STATUS eUsertype);
	int _ConvertBuddyUserUpdateType(int nUpdateType);
	bool _IsMyTransaction(trid_t trid, bool bRemove = true)
	{
		mytridmap_t::iterator it = m_mapMyTrid.find(trid);
		if(it != m_mapMyTrid.end())
		{
			if (bRemove)
			{
				m_mapMyTrid.erase(it);
			}
			return true;
		}
		return false;
	}
	void _AddMyTransaction(trid_t trid)
	{
		m_mapMyTrid.insert(mytridmap_t::value_type(trid, trid));
	}

	CBuddyGroup * _GetBuddyGroupInfo(int nGroupID);
 	CBuddyGroup * _GetBuddyGroupInfo(LPCWSTR pszGroupName);
	
	CBuddyUser * _GetBuddyInfo(int nBuddyID);
	CBuddyUser * _GetBuddyInfo(int nBuddyID, int nGroupID);
	CBuddyUser * _GetBuddyInfo(IBuddy *pBuddy);
	CBuddyUser * _GetBuddyInfo(LPCWSTR pszBuddyID);
	CBuddyUser * _GetBuddyInfo(LPCWSTR pszBuddyID, int nGroupID);

	std::vector<CBuddyUser *> _GetBuddyInfoAllGroup(IBuddy *pBuddy);

	LPCWSTR _GetBuddyID(int bBuddyID);
	LPCWSTR _GetBuddyID(int bBuddyID, int nGroupID);
	int _GetBuddyGroupID(int bBuddyID);

	CBuddyUser *_CreateBuddyInfo(IBuddy *pBuddy);
	CBuddyGroup *_CreateBuddyGroupInfo();

	bool _SetBuddyInPersistMap(CBuddyUser* pBuddyUser);
	bool _SetBuddyInPersistMap(LPCWSTR pszBuddyID, const NE_MEMBER_DATA& memberData);
	bool _SetBuddyInPersistMap(LPCWSTR pszBuddyID, int nUserStatus, LPCWSTR wszNick, int nIPTStatus, int nFlag);
	
	bool _MoveGroupBuddyInfo(CBuddyUser *pUser, int nFromGroupID, int nToGroupID);
	bool _EraseBuddyInfo(IBuddy *pBuddy);
	bool _EraseBuddyInfo(LPCWSTR pszBuddyID, int nGroupID);
	bool _EraseBuddyGroupInfo(int nID);
	void _AddEmployeeInfo(const NE_MEMBER_DATA_LIST &list);
	void _UpdateNickName(LPCWSTR wszUserId, LPCWSTR wszNickName);
	CBuddyGroup * _EraseBuddyGroupInfoWithoutDelete(int nID);
	void _ClearBuddyList(void);
	void _ClearBuddyPersistMap(void);
	void _ClearBuddyGroupList(void);
	//void _ForceCreateDefaultBuddyGroup(void);
	void _LoadURLPack(void);
	void _AdjustInviteList(void);
	void _OnLoginEnd(void);	// ¥ α    ȣ.
	void _LoginFail(IGTWASActor * pActor, trid_t trid, GTLoginErrorCode result, GTWASCallErrorCode eErrorCode);

    void _CheckValidBuddyList(void);
    bool _UpdateBuddyList(const GT_BUDDY_DATA_LIST &listBuddy);
	bool _ReloadBuddyList(const GT_BUDDY_DATA_LIST &listBuddy);
	bool _ReloadBuddyGroupList(const GT_BUDDY_GROUP_DATA_LIST &listGroup);

	bool _RefreshWorkStatus(std::wstring &strUserID, std::wstring &strWorkStaus);
    
	//  ݹ Լ
private:
	void _OnRecvedInviteMsg(LPCWSTR wszUserID, ULONG ulTime, BYTE nMemoType, LPCWSTR wszSubject, void * pMsg, ULONG ulMsgSize);


	// DLL ݹ Լ
protected:

	// _INpMsgrEvents 
	virtual void CALLBACK NpMsgr_SetLoginWorking(INpMsgr * pNpMsgr, bool bLogining);
	virtual void CALLBACK NpMsgr_OnLoginEnd(INpMsgr * pNpMsgr, int nErrorType, int nErrorCode);
	virtual void CALLBACK NpMsgr_OnReloginEnd(INpMsgr * pNpMsgr, int nErrorType, int nErrorCode);
	virtual void CALLBACK NpMsgr_OnDisconnected(INpMsgr * pNpMsgr, int nType);
	virtual void CALLBACK NpMsgr_OnKilled(INpMsgr * pNpMsgr, int nType);
	virtual void CALLBACK NpMsgr_OnResult_ChangeOnlineStatus(INpMsgr * pNpMsgr, int nErrorCode, E_MSGR_ONLINE_STATUS status);
	virtual void CALLBACK NpMsgr_OnResult_BuddyInfo_ActiveXChat(INpMsgr * pNpMsgr, std::map<WSTRING, BYTE> &mapBuddyInfo);
	virtual void CALLBACK NpMsgr_OnResult_SendMessage(INpMsgr * pNpMsgr, int nErrorCode);
	virtual void CALLBACK NpMsgr_OnResult_ChangeNick(INpMsgr * pNpMsgr, int nErrorCode, LPCWSTR pszNick);
	virtual void CALLBACK NpMsgr_OnReceive_SystemNotify(char *pSystemNotice);
	virtual void CALLBACK NpMsgr_OnReceive_NoteNotify(ULONGLONG lNoteId, LPCWSTR strFromID, LPCWSTR strFromName, ULONG nUnreadNoteCnt);
	virtual void CALLBACK NpMsgr_OnReceive_NoteUnreadCntNotify(ULONG lUnreadCnt);
	//virtual void CALLBACK NpMsgr_OnReceive_MemoNotify(LPCWSTR wszUserID, ULONG ulTime, BYTE nMemoType, LPCWSTR wszSubject, void * pMsg, ULONG ulMsgSize, int nMemoID);
	virtual void CALLBACK NpMsgr_OnReceive_MemoNotify(LPCWSTR wszUserID, ULONG ulTime, BYTE nMemoType, LPCWSTR wszSubject, void * pMsg, ULONG ulMsgSize, int nMemoID);
	virtual void CALLBACK NpMsgr_NeedUpdateLoginTicket(void);
	virtual void CALLBACK NpMsgr_CheckClientNetwork(void);

	// _INpMsgrBuddyEvents 
	virtual void CALLBACK NpMsgrBuddy_OnNotifyMessage(LPCWSTR wszId, unsigned int nUserDefinedMsgCode, const char * pMsg, int nSize);
	virtual void CALLBACK NpMsgrBuddy_OnMMCInvite(LPCWSTR wszId, LPCSTR pszPhoneTag, LPCWSTR pszPassword, LPCWSTR pszRoomTitle, LPCWSTR pszTalkName);
	virtual void CALLBACK NpMsgrBuddy_OnMMCForceKick(WORD wTimeout, LPCWSTR pszMsg1, LPCWSTR pszMsg2);
	virtual void CALLBACK NpMsgrBuddy_OnMyStatusChanged(int nChangedFlag, wstring &strNickName, BYTE nOnlineStatus, BYTE nIPTStatus);
	virtual void CALLBACK NpMsgrBuddy_OnBuddyStatusChanged(IBuddy * pBuddy, int nBuddyChangedFlag, const char *pCustomData, int nDataSize);
	virtual void CALLBACK NpMsgrBuddy_OnNotBuddyStatusChanged(LPCWSTR wszId, int nUserStatus, LPCWSTR wszNick, int nIPTStatus, int nFlag);
	virtual void CALLBACK NpMsgrBuddy_OnNotifyAddedBuddy(LPCWSTR wszId, LPCWSTR wszMsg);
	virtual void CALLBACK NpMsgrBuddy_OnSync_BuddyAdd(int nError, LPCWSTR wszErrMsg, std::map<LPCWSTR, IBuddy *> &mapAddedBuddy, IGroup * pParentGroup = NULL, int nGroupID = -1, int nAddrID = -1, int nCallerTrId = -1);
	virtual void CALLBACK NpMsgrBuddy_OnSync_BuddyRemove(int nError, bool bLast, LPCWSTR wszId, int nGroupId, bool bDelGroup, IBuddy * pBuddy, int nCallerTrId = -1);
	virtual void CALLBACK NpMsgrBuddy_OnSync_BlockBuddyAdd(int nError, LPCWSTR wszId, int nCallerTrId = -1);
	virtual void CALLBACK NpMsgrBuddy_OnSync_BlockBuddyRemove(int nError, LPCWSTR wszId, int nCallerTrId = -1);
	virtual void CALLBACK NpMsgrBuddy_OnSync_WaitBuddyRemove(int nError, LPCWSTR wszId, int nCallerTrId = -1);

	// _INpSessionDispatcher_PacketHandler 
	virtual void CALLBACK INpSessionDispatcher_OnReceive_RESPONSE_PACKET(INpSessionDispatcher * pEventSource, const INpPacket * pOriginalRequestPacket, const INpPacket * pPacket);
	virtual void CALLBACK INpSessionDispatcher_OnReceive_CToC(INpSessionDispatcher * pEventSource, USHORT usCToC_SubCMMD, const INpPacket * pPacket);

	// IGTWASActorEvent 
	virtual bool OnGTWASActor_ResponseBuddyList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, bool bAllRecvedList, const GT_BUDDY_DATA_LIST &list);
	virtual bool OnGTWASActor_ResponseBuddyGroupList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nDefaultGroupID, const GT_BUDDY_GROUP_DATA_LIST &list);
	virtual bool OnGTWASActor_ResponseMyPage(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_MYPAGE_DATA &data, const GT_API_SPEC_DATA &spec, const GT_FAQ_DATA_LIST &listFAQ, NE_LEVEL_DATA_LIST &list, int nCategoryCacheSerial);
	virtual bool OnGTWASActor_ResponseUpdateBuddy(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const vector< pair<wstring, int> > &vecBuddy, int nNewGrpID);
	virtual bool OnGTWASActor_ResponseSearchBuddy(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, bool bSuccess, GT_BUDDY_SEARCH_RESULT_DATA &data);
	virtual bool OnGTWASActor_ResponseAddGroup(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_BUDDY_GROUP_DATA &data, GTBuddyAddGroupType addGroupType);
	virtual bool OnGTWASActor_ResponseDelGroup(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nGroupID); 
	virtual bool OnGTWASActor_ResponseUpdateGroup(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nGroupID, GT_BUDDY_GROUP_UPDATABLE_DATA &data);
	virtual bool OnGTWASActor_ResponseUpdateGroupSortOrder(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, vector<GT_BUDDY_GROUP_DATA> &vecBuddyGroupData);
	virtual bool OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID);
	virtual bool OnGTWASActor_ResponseCheckClientNetwork(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode);

	// IPT
	virtual void CALLBACK NpMsgrIPT_OnNotifyCallInfo(LPCWSTR strUserID, LPCWSTR strTelNo, LPCWSTR strCID);
	virtual void CALLBACK NpMsgrIPT_OnResponsePhoneCall(BYTE result, LPCWSTR strCID);
	virtual void CALLBACK NpMsgrIPT_OnResponseForwardingInfo(BYTE ret, BYTE act, LPCWSTR strTelNo);
	virtual void CALLBACK NpMsgrIPT_OnResponseResult(BYTE ret, uint16_t usIPTCMMD);
	virtual void CALLBACK NpMsgrIPT_OnResponseDndInfo(BYTE ret, BYTE act);
	
private:
	INpMsgr *m_pNpMsgr;
	//CGTNormLog	m_log;
	
	GTLogoutReasonType m_eLogoutType;
	bool m_bIsFirstLogin;
	bool m_bLoginWorking;
    bool m_bReloginWorking;
	bool m_bMobileLoginFlag;
	bool m_bReloginOKFlag;
	bool m_bIsEverLoginOKFlag;
    bool m_bLoadBuddyList;
	
	std::string m_strTicketType;
	std::string m_strMyPhoneNumber;
	std::list<ULONG> m_listTridForNpMsgr;
	typedef std::map<ULONG, P_GT_MEMO_DATA> sendmemomap_t;
	sendmemomap_t m_mapSendMemoMapForTrid;
	
	int m_nDefaultGroupID;

	buddyvector_t		m_vecBuddy;

	//map GetUserId -> CBuddyUser *
	buddymap_t			m_mapBuddyPersist;

	buddygroupvector_t	m_vecBuddyGroup;
	employeemap_t		m_mapEmployee;
	buddylist_t			m_listBlockUserList;
	importbuddylist_t	m_vecImportBuddy;

	// WAS TRANSACTION ID =>  Actor  WAS  üũϱ .
	mytridmap_t m_mapMyTrid;

	// URL ٷ
	P_GT_URL_PACK_DATA	m_sURLPack;

	// API  
	P_GT_API_SPEC_DATA	m_sSpecInfo;

	// FAQ Ʈ 
	p_faqlist_t			m_listFAQPrivate;
	faqlist_t			m_listFAQ;

	//   Ʈ
	typedef std::map<std::string, P_GT_MOBILE_BLOCK_NUMBER_DATA> mobileblockmap_t;
	mobileblockmap_t m_mapMobileBlock;
	GTOSType m_eOSType;
	
	//   
	P_GT_MY_USER_DATA m_sMyUserData;
	NE_LEVEL_DATA_LIST m_sLevelList;

	// α  
	P_GT_LOGIN_ERROR_DATA m_sLoginErrorData;
	
	//  ø ȣ
	unsigned int m_nBuddyGroupSerial;	//  ׷
	
	IGTAuthTicketProxy * m_pAuthTicketProxy;
	nfc::CMutex m_mutexBuddy;
	
	DWORD m_pMainThreadID;

	// īװ ĳ 
	int m_nCategoryCacheSerial;

	CWASActor *				m_pWASActor;
	CProfileImageActor *	m_pProfileImageActor;


	CBuddyGroup	m_VirtualBuddyGroup;
	CBuddyUser	m_VirtualBuddyUser;

	//buddy workstatus refresh data
	vector<GT_BUDDY_WORK_STATUS_DATA> m_vecBuddyWorkStatusData;
};


